import { ElementRef } from '@angular/core';
import { BloomEffectOptions, SelectiveBloomEffect } from 'postprocessing';
import * as THREE from 'three';
import * as i0 from "@angular/core";
export type SelectiveBloomOptions = BloomEffectOptions & {
    selectionLayer: number;
    inverted: boolean;
    ignoreBackground: boolean;
};
export declare class NgtpSelectiveBloom {
    lights: import("@angular/core").InputSignal<THREE.Object3D<THREE.Object3DEventMap>[] | ElementRef<THREE.Object3D<THREE.Object3DEventMap> | undefined>[]>;
    selection: import("@angular/core").InputSignal<THREE.Object3D<THREE.Object3DEventMap> | ElementRef<THREE.Object3D<THREE.Object3DEventMap> | undefined> | THREE.Object3D<THREE.Object3DEventMap>[] | ElementRef<THREE.Object3D<THREE.Object3DEventMap> | undefined>[]>;
    options: import("@angular/core").InputSignalWithTransform<SelectiveBloomOptions, "" | Partial<SelectiveBloomOptions>>;
    private blendFunction;
    private luminanceThreshold;
    private luminanceSmoothing;
    private mipmapBlur;
    private intensity;
    private radius;
    private levels;
    private kernelSize;
    private resolutionScale;
    private width;
    private height;
    private resolutionX;
    private resolutionY;
    private inverted;
    private ignoreBackground;
    private selectionLayer;
    private store;
    private effectComposer;
    private ngtSelection;
    private resolvedLights;
    private resolvedSelected;
    private resolvedNgtSelected;
    protected effect: import("@angular/core").Signal<SelectiveBloomEffect>;
    constructor();
    private addLight;
    private removeLight;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtpSelectiveBloom, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtpSelectiveBloom, "ngtp-selective-bloom", never, { "lights": { "alias": "lights"; "required": true; "isSignal": true; }; "selection": { "alias": "selection"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
